#ifndef NOTIFICATION_COMMANDS_H
#define NOTIFICATION_COMMANDS_H

#include "Shell.h"
#include "ICameraProvider.h"

#include <P1CameraListener.hpp>
#include <thread>

class NotificationCommands
{
public:
    NotificationCommands(Shell& shell, ICameraProvider& cameraProvider);
    ~NotificationCommands();

    void HandleNotificationCommand(std::vector<std::string>& tokens);

    void NotificationThreadMain();

private:
    P1::CameraSdk::Listener* mListener = nullptr;
    std::thread* mNotificationThread = nullptr;

    ICameraProvider& mCameraProvider;

    void HandleSdkNotifCommand(std::vector<std::string>& tokens, uint32_t fieldNo);
    void HandleCameraNotifCommand(std::vector<std::string>& tokens, uint32_t fieldNo);
    void HandlePropertyNotifCommand(std::vector<std::string>& tokens, uint32_t fieldNo, bool isSpecNotif = false);
    void HandleCatchAllCommand(std::vector<std::string>& tokens, uint32_t fildNo);

    void setCameraEvent(bool enable, P1::CameraSdk::CameraEventId eventId);
};

#endif // NOTIFICATION_COMMANDS_H