#ifndef PROPERTY_COMMANDS_H
#define PROPERTY_COMMANDS_H

#include "Shell.h"
#include "ICameraProvider.h"

#include <P1CameraListener.hpp>
#include <thread>

class PropertyCommands
{
public:
    PropertyCommands(Shell& shell, ICameraProvider& cameraProvider);
    ~PropertyCommands();

    void HandlePropertyCommand(std::vector<std::string>& tokens);

private:
    ICameraProvider& mCameraProvider;

    void PrintPropertyValue(const P1::CameraSdk::PropertyValue& value, const std::string name, const int id) const;

    void HandleListCommand(std::vector<std::string>& tokens, uint32_t fieldNo);
    void HandleSetCommand(std::vector<std::string>& tokens, uint32_t fieldNo);
    void HandleGetCommand(std::vector<std::string>& tokens, uint32_t fieldNo);
};

#endif // PROPERTY_COMMANDS_H